#include "adc.h"
/* initializare ADC */
/* 
 * channel 0
 * prescaler 128
 * Vref 5V
 */
void adc_init(void)
{
	ADMUX = 0;
	ADMUX |= (1 << REFS0);         // AVCC with external capacitor at AREF pin
	ADCSRA = 0;
	ADCSRA |= (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0); //set clock prescaler at 128
	ADCSRA |= (1 << ADEN);         // enable ADC
}

uint16_t adc_read(uint8_t ch)
{
	// select the corresponding channel 0~7
	// ANDing with ’7′ will always keep the value
	// of ‘ch’ between 0 and 7
	ch &= 0b00000111;  // AND operation with 7
	ADMUX = (ADMUX & 0xF8)|ch; // clears the bottom 3 bits before ORing

	// start single convertion
	// write ’1′ to ADSC
	ADCSRA |= (1<<ADSC);

	// wait for conversion to complete
	// ADSC becomes ’0′ again
	// till then, run loop continuously
	while(ADCSRA & (1<<ADSC));

	return (ADC);
}